#  mdi2.defn.tcl

proc {Add_MDI2_Module} {name server addressdata} {
   global CurrentVMEServer

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]
   set A16addrbase [first $addressinfo]
   set A24addrbase [second $addressinfo]
   set A32addrbase [third $addressinfo]
   set interruptlevel [fourth $addressinfo]
   set interruptvector [fifth $addressinfo]

   set CurrentVMEServer  $server

   define-vme-register $name xVME address_source  "-a$A32addrbase -w32 -o0x6000 -prw -d16 -l1 -b0 -zd"
   define-vme-register $name xVME address_reg     "-a$A32addrbase -w32 -o0x6002 -prw -d16 -l16 -b0 -zx"
   define-vme-register $name xVME module_id       "-a$A32addrbase -w32 -o0x6004 -prw -d16 -l8 -b0 -zx -i1"
 
   define-vme-register $name xVME Reset           "-a$A32addrbase -w32 -o0x6008 -pwo -d16 -i0"

   define-vme-register $name xVME Data_Len        "-a$A32addrbase -w32 -o0x6030 -pro -d16 -l14 -b0 -zd"
   define-vme-register $name xVME Data_Fmt        "-a$A32addrbase -w32 -o0x6032 -prw -d16 -l2 -b0 -zd -i2"
   define-vme-register $name xVME RdOut_Reset     "-a$A32addrbase -w32 -o0x6034 -pwo -d16 -i0"
   define-vme-register $name xVME MultEvent       "-a$A32addrbase -w32 -o0x6036 -prw -d16 -l1 -b0 -zd -i0"
   define-vme-register $name xVME MarkType        "-a$A32addrbase -w32 -o0x6038 -prw -d16 -l1 -b0 -zd -i0"
   define-vme-register $name xVME Acq_Ctrl        "-a$A32addrbase -w32 -o0x603a -prw -d16 -l1 -b0 -zd -i0"
   define-vme-register $name xVME Fifo_Reset      "-a$A32addrbase -w32 -o0x603c -pwo -d16 -i0"
   define-vme-register $name xVME Data_Rdy        "-a$A32addrbase -w32 -o0x603e -pro -d16 -l1 -b0 -zd"

   define-vme-register $name xVME seq_enable      "-a$A32addrbase -w32 -o0x6040 -prw -d16 -l2 -b0 -zd -i3"
   define-vme-register $name xVME trig_source0    "-a$A32addrbase -w32 -o0x6042 -prw -d16 -l3 -b0 -zd -i7"
   define-vme-register $name xVME trig_source1    "-a$A32addrbase -w32 -o0x6044 -prw -d16 -l3 -b0 -zd -i7"
   define-vme-register $name xVME com_trig_source "-a$A32addrbase -w32 -o0x6046 -prw -d16 -l2 -b0 -zd -i3"
   define-vme-register $name xVME Gen_Trig        "-a$A32addrbase -w32 -o0x6048 -pwo -d16"
   define-vme-register $name xVME Gen_Event       "-a$A32addrbase -w32 -o0x604a -pwo -d16"

   define-vme-register $name xVME hold_delay0     "-a$A32addrbase -w32 -o0x6050 -prw -d16 -l12 -b0 -zd -i1000"
   define-vme-register $name xVME hold_delay1     "-a$A32addrbase -w32 -o0x6052 -prw -d16 -l12 -b0 -zd -i1000"
   define-vme-register $name xVME hold_width0     "-a$A32addrbase -w32 -o0x6054 -prw -d16 -l7 -b0 -zd -i34"
   define-vme-register $name xVME hold_width1     "-a$A32addrbase -w32 -o0x6056 -prw -d16 -l7 -b0 -zd -i34"

   define-vme-register $name xVME bus_watchdog    "-a$A32addrbase -w32 -o0x6060 -prw -d16 -l1 -b0 -zd -i1"
   define-vme-register $name xVME frontend_reset  "-a$A32addrbase -w32 -o0x6062 -pwo -d16"
   define-vme-register $name xVME seq_clk_freq0   "-a$A32addrbase -w32 -o0x6064 -prw -d16 -l3 -b0 -zd -i3"
   define-vme-register $name xVME seq_clk_freq1   "-a$A32addrbase -w32 -o0x6066 -prw -d16 -l3 -b0 -zd -i3"
   define-vme-register $name xVME seq_busy        "-a$A32addrbase -w32 -o0x6068 -pro -d16 -l2 -b0 -zd"
   define-vme-register $name xVME sample_delay_reg0      "-a$A32addrbase -w32 -o0x606a -prw -d16 -l4 -b0 -zd -i4"
   define-vme-register $name xVME sample_delay_reg1      "-a$A32addrbase -w32 -o0x606c -prw -d16 -l4 -b0 -zd -i4"
   define-vme-register $name xVME enable_busy     "-a$A32addrbase -w32 -o0x606e -prw -d16 -l1 -b0 -zd -i0"

   define-vme-register $name xVME seq0_mct       "-a$A32addrbase -w32 -o0x6070 -prw -d16 -l4 -b0 -zd -i0"
   define-vme-register $name xVME seq1_mct       "-a$A32addrbase -w32 -o0x6072 -prw -d16 -l4 -b0 -zd -i0"
   define-vme-register $name xVME seq0_cct       "-a$A32addrbase -w32 -o0x6074 -prw -d16 -l10 -b0 -zd -i17"
   define-vme-register $name xVME seq1_cct       "-a$A32addrbase -w32 -o0x6076 -prw -d16 -l10 -b0 -zd -i17"
   define-vme-register $name xVME allow_sync_word       "-a$A32addrbase -w32 -o0x6078 -prw -d16 -l1 -b0 -zd"

   define-vme-register $name xVME rc_busno       "-a$A32addrbase -w32 -o0x6080 -prw -d16 -l2 -b0 -zd"
   define-vme-register $name xVME rc_modnum      "-a$A32addrbase -w32 -o0x6082 -prw -d16 -l4 -b0 -zd"
   define-vme-register $name xVME rc_opcode      "-a$A32addrbase -w32 -o0x6084 -prw -d16 -l7 -b0 -zd"
   define-vme-register $name xVME rc_adr         "-a$A32addrbase -w32 -o0x6086 -prw -d16 -l8 -b0 -zd"
   define-vme-register $name xVME rc_dat         "-a$A32addrbase -w32 -o0x6088 -prw -d16 -l16 -b0 -zx"
   define-vme-register $name xVME rc_status      "-a$A32addrbase -w32 -o0x608a -prw -d16 -l4 -b0 -zd"

   define-vme-register $name xVME evctr_res      "-a$A32addrbase -w32 -o0x6090 -pwo -d16"
   define-vme-register $name xVME evctr_lo       "-a$A32addrbase -w32 -o0x6092 -pro -d16 -l16 -b0 -zx"
   define-vme-register $name xVME evctr_hi       "-a$A32addrbase -w32 -o0x6094 -pro -d16 -l16 -b0 -zx"
   define-vme-register $name xVME ts_osc_source  "-a$A32addrbase -w32 -o0x6096 -prw -d16 -l1 -b0 -zd"
   define-vme-register $name xVME ts_reset_source "-a$A32addrbase -w32 -o0x6098 -prw -d16 -l1 -b0 -zd"
   define-vme-register $name xVME ts_reset       "-a$A32addrbase -w32 -o0x609a -pwo -d16"
   define-vme-register $name xVME ts_counter_lo  "-a$A32addrbase -w32 -o0x609c -pro -d16 -l16 -b0 -zx"
   define-vme-register $name xVME ts_counter_hi  "-a$A32addrbase -w32 -o0x609e -pro -d16 -l16 -b0 -zx"

   define-vme-register $name xVME seq_time_lo    "-a$A32addrbase -w32 -o0x60a0 -pro -d16 -l16 -b0 -zx"
   define-vme-register $name xVME seq_time_hi    "-a$A32addrbase -w32 -o0x60a2 -pro -d16 -l16 -b0 -zx"
   define-vme-register $name xVME daq_time_lo    "-a$A32addrbase -w32 -o0x60a4 -pro -d16 -l16 -b0 -zx"
   define-vme-register $name xVME daq_time_hi    "-a$A32addrbase -w32 -o0x60a6 -pro -d16 -l16 -b0 -zx"
   define-vme-register $name xVME time_0         "-a$A32addrbase -w32 -o0x60a8 -pro -d16 -l16 -b0 -zx"
   define-vme-register $name xVME time_1         "-a$A32addrbase -w32 -o0x60aa -pro -d16 -l16 -b0 -zx"
   define-vme-register $name xVME time_2         "-a$A32addrbase -w32 -o0x60ac -pro -d16 -l16 -b0 -zx"
   define-vme-register $name xVME time_reset     "-a$A32addrbase -w32 -o0x60ae -pwo -d16"

   define-vme-register $name xVME tdc_active0    "-a$A32addrbase -w32 -o0x60c0 -prw -d16 -l1 -b0 -zd"
   define-vme-register $name xVME tdc_active1    "-a$A32addrbase -w32 -o0x60c2 -prw -d16 -l1 -b0 -zd"


   for {set i 0} {$i < 256} {incr i} {
      define-vme-register $name xVME Threshold$i  "-a$A32addrbase -w32 -o[expr 0x4000 + ($i * 2)] -prw -d16 -l12 -b0 -zd -i16"
   }

   define-vme-register $name bVME DataMemory      "-a[expr $A32addrbase + 0x0] -w32 -o0x0 -prw -d32 -zx -l64"
}

proc {MDI2_registers} {} {
    global registers_table

    set registers_table   {                       \
        {"Address source"          address_source}         \
        {"VME address"             address_reg}         \
        {"Module ID"               module_id}         \
        {"Buffer data length"      Data_Len}         \
        {"Data format"             Data_Fmt}         \
        {"Multievent flag"         MultEvent}        \
        {"Marking type"            MarkType}         \
        {"Acquisition control"     Acq_Ctrl}         \
        {"Data ready"              Data_Rdy}         \
        {"Sequencer enable"        seq_enable}         \
        {"Trigger source bus 0"    trig_source0}         \
        {"Trigger source bus 1"    trig_source1}         \
        {"Common trigger source"   com_trig_source}         \
        {"Gate delay bus 0"        hold_delay0}         \
        {"Gate delay bus 1"        hold_delay1}         \
        {"Gate width bus 0"        hold_width0}         \
        {"Gate width bus 1"        hold_width1}         \
        {"Bus watchdog"            bus_watchdog}         \
        {"Clock frequency bus 0"   seq_clk_freq0}         \
        {"Clock frequency bus 1"   seq_clk_freq1}         \
        {"Sequencer busy flag"     seq_busy}         \
        {"Sample delay bus 0"      sample_delay_reg0}         \
        {"Sample delay bus 1"      sample_delay_reg1}         \
        {"Enable busy signal"      enable_busy}         \
        {"Module count bus 0"      seq0_mct}         \
        {"Module count bus 1"      seq1_mct}         \
        {"17 counts needed bus 0"  seq0_cct}         \
        {"17 counts needed bus 1"  seq1_cct}         \
        {"Allow sync words"        allow_sync_word}         \
        {"RC busno"                rc_busno}         \
        {"RC moduleID"             rc_modnum}         \
        {"RC opcode"               rc_opcode}         \
        {"RC address"              rc_adr}         \
        {"RC data"                 rc_dat}         \
        {"RC return status"        rc_status}         \
        {"Event counter lo"        evctr_lo}         \
        {"Event counter hi"        evctr_hi}         \
        {"TS frequency source"     ts_osc_source}         \
        {"TS reset source"         ts_reset_source}         \
        {"TS counter lo"           ts_counter_lo}         \
        {"TS counter hi"           ts_counter_hi}         \
        {"Seq active time lo"      seq_time_lo}         \
        {"Seq active time hi"      seq_time_hi}         \
        {"DAQ time lo"             daq_time_lo}         \
        {"DAQ time hi"             daq_time_hi}         \
        {"Time lo"                 time_0}         \
        {"Time m"                  time_1}         \
        {"Time hi"                 time_2}         \
        {"TDC enable bus 0"        tdc_active0}         \
        {"TDC enable bus 1"        tdc_active1}         \
    }

    for {set i 0} {$i < 256} {incr i} {
        lappend registers_table [list "Threshold Memory ch$i"  Threshold$i]
    }
}

proc {MDI2_DAQ-reset} {args} {
#   mdi2
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#      Offline the module - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[write-vme-register $module.Reset 1] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff
}

proc {MDI2_DAQ-go} {args} {
#   mdi2
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    write-vme-register $module.RdOut_Reset 0
    write-vme-register $module.Acq_Ctrl 1
}

proc {MDI2_DAQ-halt} {args} {
#   mdi2
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    write-vme-register $module.Acq_Ctrl 0
}

proc {MDI2_DAQ-setup} {args} {
#   mdi2
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
#    initialise
    initialise-vme-registers $module.*
    write-vme-register $module.Acq_Ctrl 0
}

#   for parameter save/restore
set {MDI2_registersavepatterns} {Threshold* MarkType seq_enable trig_source0 trig_source1 com_trig_source hold_delay0 hold_delay1 hold_width0 hold_width1 seq_clk_freq0 seq_clk_freq1 \
   sample_delay_reg0 sample_delay_reg1 enable_busy seq0_mct seq1_mct seq0_cct seq1_cct ts_osc_source ts_reset_source tdc_active0 tdc_active1}


